<?php


$LinkWorth_MU = new LinkWorth_MU;
add_action('init', array(&$LinkWorth_MU, 'init'),11); 	// Initiate LW. //Passed by reference for PHP4
add_filter('generate_rewrite_rules', array($LinkWorth_MU,'rewrite')); //lw requests

class LinkWorth_MU{

	function init(){ 
		$this->add_website_ids();
		$this->update_blogs();

		if(!get_site_option('lw_wpmu_blogs_lastupdate')){ // If the options doesn't exist, this is the first run.
			$this->install();
		}

		add_filter('query_vars', array($this,'addQueryVar')); //Billboards
		add_action('parse_query', array($this,'Query')); //Billboards
	}

	/**********************************
	* Install the plugin.
	***********************************/
	function install(){	
		global $wp_rewrite;
		$wp_rewrite->flush_rules(); //Flush the rewrite rules.
		get_site_option('lw_wpmu_blogs_lastupdate',1);
	}

	/**********************************
	* Add the mod_rewrite rules to WordPress.
	* So we don't have to create a file.
	***********************************/

	function rewrite($wp_rewrite) {
	global $lw_options;

		$feed_rules = array('linkworth_mu/(.+)?' => 'index.php?linkworth_mu='. $wp_rewrite->preg_index(1));

		$wp_rewrite->rules = $feed_rules + $wp_rewrite->rules;
	}

	function addQueryVar($wpvar_array) {
	global $lw_options;

		$wpvar_array[] = 'linkworth_mu';

		return($wpvar_array);
	}

	/**********************************
	* Before we do eanything else
	* Stop and check if this is a request for the blog list
	***********************************/

	function Query() {
	global $wp_rewrite, $lw_options;
		if (LW_SITE_HASH && get_query_var('linkworth_mu') == LW_SITE_HASH) {
			$this->blog_list();
		}
	}

	function update_blogs(){
		$last = get_site_option('lw_wpmu_blogs_lastblogsupdate');
		$count = get_site_option('lw_wpmu_blogs_lastcount');
		$waiting = get_site_option('lw_wpmu_blogs_waiting');
		if((time() - $last) > 60*60*5 && $waiting != 1 && $count != get_blog_count()){ 

			@ini_set('default_socket_timeout', 10);
			$lw_blog_string = @file_get_contents('http://www.linkworth.com/act/partner/code/plugin_feed.php?ping=1&web_id=' . LW_SITE_ID . '&hash=' . LW_SITE_HASH);

			if($lw_blog_string){
				update_site_option('lw_wpmu_blogs_waiting',1);
			}else{
				update_site_option('lw_wpmu_blogs_lastblogsupdate',time()-600); //Delay the update for 10 minutes incase of server issues.
			}
		}
	}
	/**********************************
	* Loops through the website ids and add them for each blog.
	***********************************/
	function add_website_ids($force=0){
		$last = get_site_option('lw_wpmu_lastupdate');
		if((time() - $last) > 36000 || $force){ 
			@ini_set('default_socket_timeout', 10);

			$lw_blog_string = @file_get_contents('http://www.linkworth.com/act/partner/code/plugin_feed.php?web_id=' . LW_SITE_ID . '&hash=' . LW_SITE_HASH . '&format=xml&wpmu=1');

			if($lw_blog_string){
				include_once('LinkWorth_parser.php');

				$xml_parser = & new LW_XML();
				$blogs = $xml_parser->parse($lw_blog_string);
				update_option('lw_cache_time',time());
				$blogs = $blogs[linkworth][sites][site];

				if(is_array($blogs[0])){
							$lw_op = get_blog_option(1, 'lw_options');
							$lw_op[website_id] = $blogs[0][id];
							$lw_op[website_hash] = $blogs[0][hash];
							update_blog_option( 1, 'lw_options', $lw_op);
				}else{
						return;
				}

				array_shift($blogs);

				if(count($blogs)){
						foreach($blogs as $blog){

						//get blog ID.
						$url = explode('.',str_replace(array('http://','www.'),'',$blog[url]));
						$url = $url[0];
						$blog_id = get_id_from_blogname($url);
								if($blog_id){
										$lw_op = get_blog_option($blog_id, 'lw_options');
										$lw_op[website_id] = $blog[id];
										$lw_op[website_hash] = $blog[hash];
										
										update_blog_option( $blog_id, 'lw_options', $lw_op);
								}

						}
				}
				update_site_option('lw_wpmu_lastupdate',time()); //Delay the update for 10 minutes incase of server issues.
			}else{

				update_site_option('lw_wpmu_lastupdate',time()-33000); //Delay the update for 10 minutes incase of server issues.

			}
		}
	}

	function blog_list(){
	global $wpdb;

		update_site_option('lw_wpmu_blogs_waiting',0);
		update_site_option('lw_wpmu_blogs_lastblogsupdate',time());
		update_site_option('lw_wpmu_blogs_lastcount',get_blog_count());

		$blogs = $wpdb->get_results( $wpdb->prepare("SELECT blog_id, domain, path FROM $wpdb->blogs WHERE site_id = %d AND archived = '0' AND mature = '0' AND spam = '0' AND deleted = '0' ORDER BY registered DESC", $wpdb->siteid), ARRAY_A );

		foreach($blogs as $blog){
			$the_blogs[] = $blog['domain'].$blog['path'];
		}

		if(is_array($the_blogs))
			echo implode("\n",$the_blogs);

		exit;
	}	
	function update_all_options($ops){

		$blogs = get_blog_list();

		foreach($blogs as $blog){
			update_blog_option( $blog[blog_id], 'lw_options', $ops);
		}

		$this->wpmu_add_website_ids(1);
	}
}
?>